unit Datei;

interface

uses Standard;

function ReadSudokuFromFile(const Filename: string; var Grid: TGrid): Boolean;
procedure WriteSudokuToFile(const Filename: string; var Grid: TGrid);

implementation

uses Crt;

function ReadSudokuFromFile(const Filename: string; var Grid: TGrid): Boolean;
var
   F: Text;
   i, j: Integer;
   CharBuffer: Char;
begin
   ReadSudokuFromFile := True;
   Assign(F, Filename);
   {$I-} Reset(F); {$I+}
   if IOResult <> 0 then
   begin
      WriteLn('Could not open file ', Filename, ' for reading.');
      ReadSudokuFromFile := False;
      Exit;
   end;

   for i := 0 to SIZE - 1 do begin
      j := 0;
      while (j <= SIZE - 1) and not Eof(F) do begin
         Read(F, CharBuffer);
         // Check if the character is a dot for empty cells
         if (CharBuffer = LEER) or ((SIZE = 9) and (CharBuffer = '0')) then begin
            Grid[i][j] := LEER;
            Inc(j);
         end
         // Check if the character is allowed
         else if (Pos(CharBuffer, AllowedSymbols) > 0) or (CharBuffer = '.') then begin
            Grid[i][j] := CharBuffer;
            Inc(j);
         end
         // Ignore whitespace
         else if CharBuffer in [' ', #9, #10, #13] then
            Continue
         else begin
            WriteLn('Error: Invalid input in (', i, ',', j, '): "', CharBuffer, '"');
            ReadSudokuFromFile := False;
            Close(F);
            Exit;
         end;
      end;
      
      if j <= SIZE-1 then begin
         WriteLn('Error: Too few characters in row ', i);
         ReadSudokuFromFile := False;
         Close(F);
         Exit;
      end;
   end;

   Close(F);
end;

procedure WriteSudokuToFile(const Filename: string; var Grid: TGrid);
var
   F: Text;
   i, j: Integer;
begin
   Assign(F, Filename);
   {$I-} Rewrite(F); {$I+}
   if IOResult <> 0 then
   begin
      WriteLn('Could not open file ', Filename, ' for writing.');
      Exit;
   end;

   for i := 0 to SIZE-1 do
   begin
      for j := 0 to SIZE-1 do
      begin
         Write(F, Grid[i, j]:2, ' ');
      end;
      WriteLn(F);
   end;

   Close(F);
end;

end.
