program Sudoku;

{$M 16384,0,655360}

uses
   Crt, Standard, Datei, Stratege, Zeit;

const
  HelpOptions: array[1..8] of string = (
    '-h', '/h', '--h', '-help', '/help', '--help', '-?', '/?' );

var
   InputFile, OutputFile: string;
   Solved, Debug: Boolean;
   i, v, w: Integer;

begin
   { Initialisierung }
   ClrScr;
   InputFile := 'sudoku.txt';   { Standard-Eingabedatei }
   OutputFile := 'loesung.txt'; { Standard-Ausgabedatei }
   Debug := False;

   { Kommandozeilenparameter prüfen (vereinfachte Version) }
   if ParamCount >= 1 then begin
      for i := Low(HelpOptions) to High(HelpOptions) do begin
         if ParamStr(1) = HelpOptions[i] then begin
            Writeln('Sudoku sudoku.txt loesung.txt 9 debug');
            Halt;
         end;
      end;
      InputFile := ParamStr(1);
   end;
   if ParamCount >= 2 then
      OutputFile := ParamStr(2);
   if ParamCount >= 3 then begin
      VAL(ParamStr(3), v,w);
      if w=0 then SIZE := v
   end;
   if ParamCount >= 4 then
      Debug := True;

   if SIZE = 9 then
      allowedSymbols := '123456789'
   else if SIZE = 16 then
      allowedSymbols := '0123456789ABCDEF'
   else if SIZE = 25 then
      allowedSymbols := 'ABCDEFGHIJKLMNOPQRSTUVWXY'
   else begin
      Writeln('SIZE ', SIZE, ' not possible ');
      Halt(-1);
   end;
   Grid345 := trunc(sqrt(SIZE));

   { Sudoku aus Datei lesen }
   WriteLn('Reading Sudoku from file: ', InputFile);
   if not ReadSudokuFromFile(InputFile, Grid) then begin
      readln;
      Halt(1);
   end;

   { Gültigkeit prüfen }
   if not IsValidGrid(Grid, Debug) then
   begin
      WriteLn('Error: Input file contains invalid Sudoku. Please check task.');
      readln;
      Halt(1);
   end;

   { Sudoku ausgeben }
   WriteLn('Starting task Sudoku:');
   PrintGrid(Grid, True, True);

   { Startzeit erfassen }
   Writeln(Intervall_Start(1));

   { Sudoku lösen }
   WriteLn('Solving Sudoku ...');
   Solved := SolveSudokuBackTracking(Grid, Debug);

   { Endzeit erfassen }
   Writeln(Intervall_Stop(1));
   Writeln(Intervall_Dauer(1));

   if Solved then begin
      WriteLn('Solved Sudoku:');
      PrintGrid(Grid, False, False);

      { Lösung in Datei schreiben }
      WriteLn('Writing solution to file: ', OutputFile);
      WriteSudokuToFile(OutputFile, Grid);
   end
   else
      WriteLn('No solution exists.');

   WriteLn('End Program.');
   Readln;
end.
